/**
 * This code was AUTOGENERATED using the codama library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun codama to update it.
 *
 * @see https://github.com/codama-idl/codama
 */

import {
  combineCodec,
  getAddressDecoder,
  getAddressEncoder,
  getArrayDecoder,
  getArrayEncoder,
  getStructDecoder,
  getStructEncoder,
  getU8Decoder,
  getU8Encoder,
  transformEncoder,
  type Address,
  type Codec,
  type Decoder,
  type Encoder,
  type IAccountMeta,
  type IAccountSignerMeta,
  type IInstruction,
  type IInstructionWithAccounts,
  type IInstructionWithData,
  type ReadonlyAccount,
  type ReadonlySignerAccount,
  type TransactionSigner,
  type WritableAccount,
  type WritableSignerAccount,
} from '@solana/kit';
import { SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS } from '../programs';
import { getAccountMetaFactory, type ResolvedAccount } from '../shared';

export const CHANGE_AUTHORIZED_SIGNERS_DISCRIMINATOR = 3;

export function getChangeAuthorizedSignersDiscriminatorBytes() {
  return getU8Encoder().encode(CHANGE_AUTHORIZED_SIGNERS_DISCRIMINATOR);
}

export type ChangeAuthorizedSignersInstruction<
  TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS,
  TAccountPayer extends string | IAccountMeta<string> = string,
  TAccountAuthority extends string | IAccountMeta<string> = string,
  TAccountCredential extends string | IAccountMeta<string> = string,
  TAccountSystemProgram extends
    | string
    | IAccountMeta<string> = '11111111111111111111111111111111',
  TRemainingAccounts extends readonly IAccountMeta<string>[] = [],
> = IInstruction<TProgram> &
  IInstructionWithData<Uint8Array> &
  IInstructionWithAccounts<
    [
      TAccountPayer extends string
        ? WritableSignerAccount<TAccountPayer> &
            IAccountSignerMeta<TAccountPayer>
        : TAccountPayer,
      TAccountAuthority extends string
        ? ReadonlySignerAccount<TAccountAuthority> &
            IAccountSignerMeta<TAccountAuthority>
        : TAccountAuthority,
      TAccountCredential extends string
        ? WritableAccount<TAccountCredential>
        : TAccountCredential,
      TAccountSystemProgram extends string
        ? ReadonlyAccount<TAccountSystemProgram>
        : TAccountSystemProgram,
      ...TRemainingAccounts,
    ]
  >;

export type ChangeAuthorizedSignersInstructionData = {
  discriminator: number;
  signers: Array<Address>;
};

export type ChangeAuthorizedSignersInstructionDataArgs = {
  signers: Array<Address>;
};

export function getChangeAuthorizedSignersInstructionDataEncoder(): Encoder<ChangeAuthorizedSignersInstructionDataArgs> {
  return transformEncoder(
    getStructEncoder([
      ['discriminator', getU8Encoder()],
      ['signers', getArrayEncoder(getAddressEncoder())],
    ]),
    (value) => ({
      ...value,
      discriminator: CHANGE_AUTHORIZED_SIGNERS_DISCRIMINATOR,
    })
  );
}

export function getChangeAuthorizedSignersInstructionDataDecoder(): Decoder<ChangeAuthorizedSignersInstructionData> {
  return getStructDecoder([
    ['discriminator', getU8Decoder()],
    ['signers', getArrayDecoder(getAddressDecoder())],
  ]);
}

export function getChangeAuthorizedSignersInstructionDataCodec(): Codec<
  ChangeAuthorizedSignersInstructionDataArgs,
  ChangeAuthorizedSignersInstructionData
> {
  return combineCodec(
    getChangeAuthorizedSignersInstructionDataEncoder(),
    getChangeAuthorizedSignersInstructionDataDecoder()
  );
}

export type ChangeAuthorizedSignersInput<
  TAccountPayer extends string = string,
  TAccountAuthority extends string = string,
  TAccountCredential extends string = string,
  TAccountSystemProgram extends string = string,
> = {
  payer: TransactionSigner<TAccountPayer>;
  authority: TransactionSigner<TAccountAuthority>;
  /** Credential the Schema is associated with */
  credential: Address<TAccountCredential>;
  systemProgram?: Address<TAccountSystemProgram>;
  signers: ChangeAuthorizedSignersInstructionDataArgs['signers'];
};

export function getChangeAuthorizedSignersInstruction<
  TAccountPayer extends string,
  TAccountAuthority extends string,
  TAccountCredential extends string,
  TAccountSystemProgram extends string,
  TProgramAddress extends
    Address = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS,
>(
  input: ChangeAuthorizedSignersInput<
    TAccountPayer,
    TAccountAuthority,
    TAccountCredential,
    TAccountSystemProgram
  >,
  config?: { programAddress?: TProgramAddress }
): ChangeAuthorizedSignersInstruction<
  TProgramAddress,
  TAccountPayer,
  TAccountAuthority,
  TAccountCredential,
  TAccountSystemProgram
> {
  // Program address.
  const programAddress =
    config?.programAddress ?? SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS;

  // Original accounts.
  const originalAccounts = {
    payer: { value: input.payer ?? null, isWritable: true },
    authority: { value: input.authority ?? null, isWritable: false },
    credential: { value: input.credential ?? null, isWritable: true },
    systemProgram: { value: input.systemProgram ?? null, isWritable: false },
  };
  const accounts = originalAccounts as Record<
    keyof typeof originalAccounts,
    ResolvedAccount
  >;

  // Original args.
  const args = { ...input };

  // Resolve default values.
  if (!accounts.systemProgram.value) {
    accounts.systemProgram.value =
      '11111111111111111111111111111111' as Address<'11111111111111111111111111111111'>;
  }

  const getAccountMeta = getAccountMetaFactory(programAddress, 'programId');
  const instruction = {
    accounts: [
      getAccountMeta(accounts.payer),
      getAccountMeta(accounts.authority),
      getAccountMeta(accounts.credential),
      getAccountMeta(accounts.systemProgram),
    ],
    programAddress,
    data: getChangeAuthorizedSignersInstructionDataEncoder().encode(
      args as ChangeAuthorizedSignersInstructionDataArgs
    ),
  } as ChangeAuthorizedSignersInstruction<
    TProgramAddress,
    TAccountPayer,
    TAccountAuthority,
    TAccountCredential,
    TAccountSystemProgram
  >;

  return instruction;
}

export type ParsedChangeAuthorizedSignersInstruction<
  TProgram extends string = typeof SOLANA_ATTESTATION_SERVICE_PROGRAM_ADDRESS,
  TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[],
> = {
  programAddress: Address<TProgram>;
  accounts: {
    payer: TAccountMetas[0];
    authority: TAccountMetas[1];
    /** Credential the Schema is associated with */
    credential: TAccountMetas[2];
    systemProgram: TAccountMetas[3];
  };
  data: ChangeAuthorizedSignersInstructionData;
};

export function parseChangeAuthorizedSignersInstruction<
  TProgram extends string,
  TAccountMetas extends readonly IAccountMeta[],
>(
  instruction: IInstruction<TProgram> &
    IInstructionWithAccounts<TAccountMetas> &
    IInstructionWithData<Uint8Array>
): ParsedChangeAuthorizedSignersInstruction<TProgram, TAccountMetas> {
  if (instruction.accounts.length < 4) {
    // TODO: Coded error.
    throw new Error('Not enough accounts');
  }
  let accountIndex = 0;
  const getNextAccount = () => {
    const accountMeta = instruction.accounts![accountIndex]!;
    accountIndex += 1;
    return accountMeta;
  };
  return {
    programAddress: instruction.programAddress,
    accounts: {
      payer: getNextAccount(),
      authority: getNextAccount(),
      credential: getNextAccount(),
      systemProgram: getNextAccount(),
    },
    data: getChangeAuthorizedSignersInstructionDataDecoder().decode(
      instruction.data
    ),
  };
}
